
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VideosDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const videos = await db.videos.create(
            {
                id: data.id || undefined,
        
        video_type: data.video_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        video_url: data.video_url
        ||
        null
            ,
            
        site: data.site
        ||
        null
            ,
            
        external_key: data.external_key
        ||
        null
            ,
            
        size: data.size
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await videos.setTitle( data.title || null, {
            transaction,
        });
        

        

        

        return videos;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const videosData = data.map((item, index) => ({
                id: item.id || undefined,
                
                video_type: item.video_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                video_url: item.video_url
            ||
            null
            ,
            
                site: item.site
            ||
            null
            ,
            
                external_key: item.external_key
            ||
            null
            ,
            
                size: item.size
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const videos = await db.videos.bulkCreate(videosData, { transaction });

        // For each item created, replace relation files
        

        return videos;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const videos = await db.videos.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.video_type !== undefined) updatePayload.video_type = data.video_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.video_url !== undefined) updatePayload.video_url = data.video_url;
        
        
        if (data.site !== undefined) updatePayload.site = data.site;
        
        
        if (data.external_key !== undefined) updatePayload.external_key = data.external_key;
        
        
        if (data.size !== undefined) updatePayload.size = data.size;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await videos.update(updatePayload, {transaction});

        
        
        if (data.title !== undefined) {
            await videos.setTitle(
              
              data.title,
              
              { transaction }
            );
        }
        

        
        

        

        return videos;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const videos = await db.videos.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of videos) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of videos) {
                await record.destroy({transaction});
            }
        });


        return videos;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const videos = await db.videos.findByPk(id, options);

        await videos.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await videos.destroy({
            transaction
        });

        return videos;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const videos = await db.videos.findOne(
            { where },
            { transaction },
        );

        if (!videos) {
            return videos;
        }

        const output = videos.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.title = await videos.getTitle({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.titles,
        as: 'title',
        
        where: filter.title ? {
          [Op.or]: [
            { id: { [Op.in]: filter.title.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.title.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'videos',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.video_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'videos',
                        'video_url',
                        filter.video_url,
                    ),
                };
            }
            
            if (filter.site) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'videos',
                        'site',
                        filter.site,
                    ),
                };
            }
            
            if (filter.external_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'videos',
                        'external_key',
                        filter.external_key,
                    ),
                };
            }
            

            
            

            
            if (filter.sizeRange) {
                const [start, end] = filter.sizeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    size: {
                    ...where.size,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    size: {
                    ...where.size,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.video_type) {
                where = {
                    ...where,
                video_type: filter.video_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.videos.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'videos',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.videos.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

